#
# Conditional build:
%bcond_with	bootstrap	# no ffmpeg/gpac support in x264 utility
%bcond_without	asm		# disable asm

%ifnarch %{ix86} %{x8664}
%undefine	with_asm
%endif

%define		rel	6
%define		snap	20140824
%define		snaph	2245
Summary:	H264 encoder library
Summary(pl.UTF-8):	Biblioteka kodująca H264
Name:		libx264
Version:	0.1.3
Release:	1.%{snap}_%{snaph}.%{rel}
License:	GPL v2+
Group:		Libraries
# still no releases, use snapshots
Source0:	ftp://ftp.videolan.org/pub/videolan/x264/snapshots/x264-snapshot-%{snap}-%{snaph}.tar.bz2
# Source0-md5:	d2a779a864254ca426dfb1f3115987a0
Patch0:		%{name}-alpha.patch
Patch1:		altivec-no-vand.patch
Patch2:		%{name}-gpac.patch
Patch3:		x32.patch
URL:		http://www.videolan.org/developers/x264.html
BuildRequires:	pkgconfig
%{?with_asm:BuildRequires:	yasm >= 1.2.0}
%if %{without bootstrap}
# which version exactly???
# for full x264 CLI utility functionality it wants:
# libswscale >= 0.9.0 (in pkgconfig file)
# libav{format,codec,util} from ffmpeg >= r21854
BuildRequires:	ffmpeg-devel >= 0.7.1
BuildRequires:	ffmpegsource-devel >= 2.16
# gpac >= 2007-06-21
BuildRequires:	gpac-devel >= 0.5.0-3
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# encoder/macroblock.c breaks strict-aliasing rules
%define		specflags	-fno-strict-aliasing

%description
libx264 library for encoding H264 video format.

%description -l pl.UTF-8
Biblioteka libx264 do kodowania w formacie obrazu H264.

%package devel
Summary:	Header files for x264 library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki x264
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for x264 library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki x264.

%package static
Summary:	Static x264 library
Summary(pl.UTF-8):	Statyczna biblioteka x264
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static x264 library.

%description static -l pl.UTF-8
Statyczna biblioteka x264.

%package -n x264
Summary:	x264 CLI decoder
Summary(pl.UTF-8):	Dekoder x264 działający z linii poleceń
Group:		Applications/Multimedia
Requires:	%{name} = %{version}-%{release}
%if %{without bootstrap}
Requires:	gpac >= 0.5.0-3
%endif

%description -n x264
x264 CLI decoder.

%description -n x264 -l pl.UTF-8
Dekoder x264 działający z linii poleceń.

%prep
%setup -q -n x264-snapshot-%{snap}-%{snaph}
%patch0 -p1
%if "%{pld_release}" == "ac"
%patch1 -p1
%endif
%patch2 -p1
%patch3 -p1

%build
CC="%{__cc}" \
./configure \
	--host=%{_target_platform} \
	--prefix=%{_prefix} \
	--exec-prefix=%{_prefix} \
	--bindir=%{_bindir} \
	--includedir=%{_includedir} \
	--libdir=%{_libdir} \
	--extra-cflags="%{rpmcflags}" \
	%{!?with_asm:--disable-asm} \
	--enable-pic \
	--enable-shared \
	--enable-static

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS
%attr(755,root,root) %{_libdir}/libx264.so.142

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libx264.so
%{_includedir}/x264.h
%{_includedir}/x264_config.h
%{_pkgconfigdir}/x264.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libx264.a

%files -n x264
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/x264
%changelog
* Thu May 28 2015 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/libx264.git;a=log;h=cb936077803f8c820cbd119f55f4743e82e42a2d

* Thu Mar 05 2015 Jan Rękorajski <baggins@pld-linux.org> cb93607
- apply x32 patch
- rel 6

* Thu Mar 05 2015 Jan Rękorajski <baggins@pld-linux.org> a1e7167
- rel 5

* Thu Mar 05 2015 Jan Rękorajski <baggins@pld-linux.org> b841a03
- fix building on x32, no asm here

* Thu Feb 26 2015 Elan Ruusamäe <glen@delfi.ee> f60d96b
- x32 rebuild
- release 4 (by relup.sh)

* Thu Feb 26 2015 Elan Ruusamäe <glen@delfi.ee> c010e22
- add yasm bcond

* Thu Feb 26 2015 Elan Ruusamäe <glen@delfi.ee> 9154b04
- correct yasm BR

* Thu Feb 26 2015 Elan Ruusamäe <glen@delfi.ee> 460a5db
- BR yasm on x32

* Tue Oct 07 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 26bbe68
- release 3 (by relup.sh)

* Thu Sep 11 2014 Jan Rękorajski <baggins@pld-linux.org> 9280e3c
- rel 2

* Mon Aug 25 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 46529d0
- up to 20140824

* Sat Mar 29 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 748e513
- up to 20140328

* Wed Aug 28 2013 Jan Rękorajski <baggins@pld-linux.org> bd15fec
- new soname

* Wed Aug 28 2013 Jan Rękorajski <baggins@pld-linux.org> 7d6d395
- rel 1

* Wed Aug 28 2013 Jan Rękorajski <baggins@pld-linux.org> 17deb33
- up to 20130827 snapshot

* Sun Feb 03 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> b07e85f
- release 8 (by relup.sh)

* Thu Nov 08 2012 Jan Rękorajski <baggins@pld-linux.org> 9dcf5e7
- rel 7

* Sat Oct 06 2012 Jakub Bogusz <qboosh@pld-linux.org> fa46452
- release 6: rebuild with gpac on DirectFB 1.6.x

* Fri Oct 05 2012 Jakub Bogusz <qboosh@pld-linux.org> 2cdf920
- rel 5.1 for bootstrap build

* Fri Oct 05 2012 Jakub Bogusz <qboosh@pld-linux.org> c6f8df1
- moved gpac dependency where it belongs (x264 package)

* Tue Oct 02 2012 Jan Rękorajski <baggins@pld-linux.org> 199c0c2
- updated gpac R/BR to version that exports all needed functions
- rel 5

